require 'rails/generators'

module Skeletor
  module Generators
    class InstallGenerator < Rails::Generators::Base
      source_root File.join(File.dirname(__FILE__), '..', 'templates')

      def add_assets
        insert_into_file "app/assets/javascripts/application#{detect_js_format[0]}", "#{detect_js_format[1]} require skeletor_backbone\n", :after => "jquery_ujs\n"

        # settings_file = File.read("#{SkeletorBackbone::css_path}/_settings.sass")
        # create_file "app/assets/stylesheets/skeletor_and_settings.sass", File.read(settings_file)
        `sass-convert --from sass --to scss "#{SkeletorBackbone::css_path}/_settings.sass" "app/assets/stylesheets/skeletor_backbone.scss"`
        append_to_file "app/assets/stylesheets/skeletor_backbone.scss", "\n@import \"skeletor\";\n"
        #insert_into_file "app/assets/stylesheets/application#{detect_css_format[0]}", "\n#{detect_css_format[1]} require normalize \n#{detect_css_format[1]} require skeletor_backbone", :after => "require_self"
        insert_into_file "app/assets/stylesheets/application#{detect_css_format[0]}", "\n#{detect_css_format[1]} require skeletor_backbone", :after => "require_self"
      end

      def detect_js_format
        return ['.coffee', '#='] if File.exist?('app/assets/javascripts/application.coffee')
        return ['.js.coffee', '#='] if File.exist?('app/assets/javascripts/application.js.coffee')
        return ['.js', '//='] if File.exist?('app/assets/javascripts/application.js')
      end

      def detect_css_format
        return ['.css', ' *='] if File.exist?('app/assets/stylesheets/application.css')
        return ['.css.sass', '//='] if File.exist?('app/assets/stylesheets/application.css.sass')
        return ['.sass', '//='] if File.exist?('app/assets/stylesheets/application.sass')
        return ['.css.scss', '//='] if File.exist?('app/assets/stylesheets/application.css.scss')
        return ['.scss', '//='] if File.exist?('app/assets/stylesheets/application.scss')
      end

    end
  end
end
