require 'sass'

module Sass::Script::Functions
  # Sass Math Helpers
  def power(base, exponent)
    base = base.value.to_f
    exponent = exponent.value.to_f
    result = base ** exponent
    Sass::Script::Number.new(result)
  end

  # Return Calculated Modular Scale Values
  def calculate_ms_ratio(num1, num2)
    value = num1 / num2
    return value
  end

  def golden_ratio
    result = (1.0 / 2.0) + (Math.sqrt(5) / 2.0)
    Sass::Script::Number.new(result)
  end

  def minor_second
    result = calculate_ms_ratio(16, 15.0)
    Sass::Script::Number.new(result)
  end

  def major_second
    result = calculate_ms_ratio(9, 8.0)
    Sass::Script::Number.new(result)
  end

  def minor_third
    result = calculate_ms_ratio(6, 5.0)
    Sass::Script::Number.new(result)
  end

  def major_third
    result = calculate_ms_ratio(5, 4.0)
    Sass::Script::Number.new(result)
  end

  def perfect_fourth
    result = calculate_ms_ratio(4, 3.0)
    Sass::Script::Number.new(result)
  end

  def augmented_fourth
    result = calculate_ms_ratio(Math.sqrt(2), 1.0)
    Sass::Script::Number.new(result)
  end

  def diminished_fifth
    return augmented_fourth
  end

  def perfect_fifth
    result = calculate_ms_ratio(3, 2.0)
    Sass::Script::Number.new(result)
  end

  def minor_sixth
    result = calculate_ms_ratio(8, 5.0)
    Sass::Script::Number.new(result)
  end

  def major_sixth
    result = calculate_ms_ratio(5, 3.0)
    Sass::Script::Number.new(result)
  end

  def minor_seventh
    result = calculate_ms_ratio(16, 9.0)
    Sass::Script::Number.new(result)
  end

  def major_seventh
    result = calculate_ms_ratio(15, 8.0)
    Sass::Script::Number.new(result)
  end

  def octave
    result = calculate_ms_ratio(2, 1.0)
    Sass::Script::Number.new(result)
  end

  def major_tenth
    result = calculate_ms_ratio(5, 2.0)
    Sass::Script::Number.new(result)
  end

  def major_eleventh
    result = calculate_ms_ratio(8, 3.0)
    Sass::Script::Number.new(result)
  end

  def major_twelfth
    result = calculate_ms_ratio(3, 1.0)
    Sass::Script::Number.new(result)
  end

  def double_octave
    result = calculate_ms_ratio(4, 1.0)
    Sass::Script::Number.new(result)
  end

end
